
/* Ascensor de 3 pisos.
http://tecnoloxia.org */

// Declaración de variables:

// Control do motor: 
const int E1 = 10;   // Enable pin
const int I1 = 9;    // Control pin 1
const int I2 = 8;    // Control pin 2

// Pulsadores
const int pulsador0 = 2;    
const int pulsador1 = 3;    
const int pulsador2 = 4;   

// Sensores dos pisos
const int fc0= 5;  
const int hall1=6;  
const int fc2= 7;  

// Rexistro de desprazamento
int latchPin = 13 ;             
int clockPin = 12;     
int dataPin = 11;     

// datos parar o display 7seg 

byte dixito[] ={                                        
  B00000010,    // escribe 0   
  B10011110,    // escribe 1 
  B00100100,    // escribe 2  
  B00001100,    // escribe 3  
  B10011000,    // escribe 4  
  B01001000,    // escribe 5  
  B01000000,    // escribe 6  
  B00011110,    // escribe 7  
  B00000000,    // escribe 8  
  B00011000,    // escribe 9  
  B11111111     // apagado
  };

int chamada;
int piso;

// Configuración:

void setup(){
  pinMode( E1, OUTPUT);        // Configuramos os pins
  pinMode( I1, OUTPUT);
  pinMode( I2, OUTPUT);

  pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  
  Serial.begin(9600);         // Inicia a comunicación serie 
}

// Programa:

// Funcións

void subir() {
  digitalWrite(E1, HIGH);     // Activamos Motor1
  digitalWrite(I1, HIGH);     // Xira cara á subir    
  digitalWrite(I2, LOW);   
  Serial.println("subir");
  }
void baixar() {
  digitalWrite(E1, HIGH);     // Activamos Motor1
  digitalWrite(I1, LOW);      // Xira cara á baixar
  digitalWrite(I2, HIGH);
  Serial.println("baixar"); 
  }
void parar() {
  digitalWrite(E1, LOW);      // pararmos Motor 1
  Serial.println("parar"); 
  }

void Display(byte numero){    
  digitalWrite(latchPin, LOW) ; 
  shiftOut(dataPin, clockPin, LSBFIRST, dixito[numero]);
  digitalWrite(latchPin, HIGH) ; 
}

void chamar() {
  if (digitalRead(pulsador0)==HIGH){
    chamada=0;
    }
  if (digitalRead(pulsador1)==HIGH){
    chamada=1;
    }
  if (digitalRead(pulsador2)==HIGH){
    chamada=2;
    }
}

void deteccionPiso() {
  if (digitalRead(fc0)==HIGH){
    piso=0;
    Display(piso);
    }
  if (digitalRead(hall1)==HIGH){
    piso=1;
    Display(piso);
    }
  if (digitalRead(fc2)==HIGH){
    piso=2;
    Display(piso);
    }
}

// Fin funcións

void loop() {

  deteccionPiso();
  chamar();

    while(!(piso == chamada)){
      if (piso>chamada){
        baixar();
        }
      if (piso<chamada) {
        subir();
        }
      deteccionPiso();
    }
    parar();

  }

  

